unit Btmicon;

interface

uses   { The Following code makes it possible to compile in delphi 1 or 2 }
  {$IFDEF WIN32}
			Windows,ComCtrls,
		{$ELSE}
			WinTypes, WinProcs,
		{$ENDIF}
  SysUtils, Messages, Classes, Graphics, Controls,Forms, Dialogs,
  StdCtrls, FileCtrl, ExtCtrls, Grids, Buttons,Spin,DsgnIntf,
  TabNotBk,SHELLAPI, Clipbrd,GetPath;

const
  {$IFDEF WIN32}
     IsWin32 = true;
     ExeDLLHistory = 'C:\Windows\ExeDLL2.hst';
     BitMapHistory = 'C:\Windows\BitMap2.hst';
     GraphicPaths  = 'C:\Windows\GraphicPaths.pat';
  {$ELSE}
     ExeDLLHistory = 'C:\Windows\ExeDLL.hst';
     BitMapHistory = 'C:\Windows\BitMap.hst';
     GraphicPaths  = 'C:\Windows\GrphPath.pat';
  {$ENDIF}
           { instead of using the win95 trash can and to make this    }
           { this source compatible with win 3.1 I use a directory to }
           { hold the deleted icons.  You can use the file Maniger or }
           { File explorer to hard delete the icons                   }
     DeletePath = 'C:\pvDeleted';
type
    TGraphicType = (pvPicture,pvIcon, pvBitMap,pvMetaFile,pvNone);
    TpvBitMapIcon = class(TForm)
    TabbedNotebook1: TTabbedNotebook;
    SpeedButtonTest: TSpeedButton;
    Panel1: TPanel;
    DriveComboBox1: TDriveComboBox;
    DirectoryListBox1: TDirectoryListBox;
    BitBtnTest: TBitBtn;
    SpinEditGlyphs: TSpinEdit;
    MakeFit: TCheckBox;
    Panel2: TPanel;
    image: TImage;
    ListGraphicFiles: TFileListBox;
    DrawGraphicGrid: TDrawGrid;
    Panel3: TPanel;
    DirectoryListBox2: TDirectoryListBox;
    DrawIcons: TDrawGrid;
    DriveComboBox2: TDriveComboBox;
    Panel4: TPanel;
    FileListDllExe: TFileListBox;
    SaveIcon: TBitBtn;
    SaveDialog: TSaveDialog;
    ReturnFile: TBitBtn;
    BitBtnCancel: TBitBtn;
    ReturnExe: TBitBtn;
    GridExeFit: TCheckBox;
    BmpSize: TLabel;
    Panel5: TPanel;
    IconImage: TImage;
    BitMapHstList: TComboBox;
    ExeDllHstList: TComboBox;
    BitBtnConvert: TBitBtn;
    SaveDialogBMP: TSaveDialog;
    NbrRead: TLabel;
    NbrIconRead: TLabel;
    BitBtnClear: TBitBtn;
    BitBtnIconTest: TBitBtn;
    procedure FormCreate(Sender: TObject);
    procedure DirectoryListBox1Change(Sender: TObject);
    procedure ListGraphicFilesClick(Sender: TObject);
    procedure DrawGraphicGridDrawCell(Sender: TObject; Col, Row: Longint;
      Rect: TRect; State: TGridDrawState);
    procedure DrawGraphicGridClick(Sender: TObject);
    procedure SpinEditGlyphsChange(Sender: TObject);
    Procedure AssignBitMapIcon(CellIndex: Integer);
    procedure MakeFitClick(Sender: TObject);
    procedure FormMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FileListDllExeClick(Sender: TObject);
    procedure DrawIconsDrawCell(Sender: TObject; Col, Row: Longint;
      Rect: TRect; State: TGridDrawState);
    procedure SetDllExeValues;
    procedure PlaceTheFormCaption;
    procedure DirectoryCheckSlash;
    procedure DirectoryListBox2Click(Sender: TObject);
    procedure DrawIconsClick(Sender: TObject);
    procedure DirectoryListBox2Change(Sender: TObject);
    procedure SaveIconClick(Sender: TObject);
    procedure GridExeFitClick(Sender: TObject);
    procedure BitBtnConvertClick(Sender: TObject);
    procedure ReturnFileClick(Sender: TObject);
    procedure ReturnExeClick(Sender: TObject);
    procedure BitMapHstListClick(Sender: TObject);
    procedure ExeDllHstListClick(Sender: TObject);
    procedure ExeDllHstListKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure TabbedNotebook1Change(Sender: TObject; NewTab: Integer;
      var AllowChange: Boolean);
    procedure FormShow(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure BitBtnCancelClick(Sender: TObject);
    procedure BitBtnClearClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure DrawGraphicGridDblClick(Sender: TObject);
    procedure DrawGraphicGridKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    Function PerformDeletion : Boolean;
   {$IFDEF WIN32}
	    	Function WinExecAndWait(FileName:String; Visibility : integer):integer;
		{$ELSE}
			  Function WinExecAndWait(Path : Pchar; Visibility : word) : word;
  {$ENDIF}

  private
    { Private declarations }

     DllExeFileName,CurrentDllExeDirectory,
     CurrentBmpDirectory,FExeDllName,ExeDllName  : TFileName;
     TheIndex,MaxIcons,FIconNbr,TheIconIndex,SelectedGraphic : Integer;
     str : array[0..126] of char;

  Public
    RunExternal : Boolean;
    LastCell : Integer;
    GraphicType,Extension : TGraphicType;
    FBitMapName : TFileName;
    GraphicName : String[60];
    Procedure ConvertIcon(bm : TBitMap);
    { Public declarations }
  end;

TpvBitMapIconEditor = class(TClassProperty)
	public
		procedure Edit; override;
   function GetAttributes: TPropertyAttributes; override;
		end;

procedure Register;

var
  BitMapEditor,IconEditor,MetaFileEditor : String[255];
  Editor: TpvBitMapIcon;
  {pvBitMapIcon : TpvBitMapIcon;} 

implementation

 {$R *.DFM}
uses
   Launche;

procedure Register;
       { These three calls allow this editor to be called whenever a property }
       { of TPicture, Ticon, or TBitMap is selected }
begin
   RegisterPropertyEditor(TypeInfo(TPicture), nil, 'Picture', TpvBitMapIconEditor);
   RegisterPropertyEditor(TypeInfo(TIcon), nil, 'Icon', TpvBitMapIconEditor);
   RegisterPropertyEditor(TypeInfo(TBitMap), nil, 'Glyph', TpvBitMapIconEditor);
end;

function TpvBitMapIconEditor.GetAttributes: TPropertyAttributes;
	begin
		Result := [paDialog, paAutoUpdate];
	end;

procedure TpvBitMapIconEditor.Edit;
var
 bm : TPicture;
 str : array[0..255] of char; { calling this the max filename length}
 TheResult : integer;

 {The Value property reflects the value of the property being edited.}
Begin
  Editor := TpvBitMapIcon.Create(Application);
   { setup the case and properties for the editor, property that invoked }
  if Value = '(TPicture)' Then   { the editor }
    Editor.GraphicType := pvPicture
    else if Value = '(TIcon)' then
           Editor.GraphicType := pvIcon
         else if Value = '(TBitmap)' then
                Editor.GraphicType := pvBitMap;
  { Display Current Graphic for tab 0 }
  case Editor.GraphicType of
     pvPicture :  Editor.Image.Picture := TPicture(GetOrdValue);
     pvIcon    :  Editor.Image.Picture.Icon := TIcon(GetOrdValue);
     pvBitMap  :  Editor.Image.Picture.BitMap := TBitMap(GetOrdValue);
  end;
  { set Graphic name for the Form Title }
  Editor.GraphicName := Value;
  { invoke the dialog }
  TheResult := Editor.ShowModal;
  bm := TPicture.Create;
  try
  case TheResult of
    mrOk :  { Tab 0 Return }
      begin
        case Editor.graphicType of
          pvPicture : if Editor.Extension in [pvBitMap, pvIcon, pvMetaFile] then
                        begin  { Get graphic and return it }
                          try  { to ensure correct Graphic format }
                            bm.LoadFromFile(Editor.FBitMapName);
                            SetOrdValue(Longint(bm));
                          except
                          End;{except}
                        end;{  TPicture Result }

          pvIcon :  if Editor.Extension = pvIcon then
                     Begin  { to ensure correct Graphic format }
                       Try { Get graphic and return it }
                         bm.icon.LoadFromFile(Editor.FBitMapName);
                         SetOrdValue(Longint(bm.icon));
                       except
                       End;{except}
                     End; { TIcon Result }

          pvBitMap : begin
                       try { Get graphic and return it }
                         if Editor.Extension = pvBitMap then
                           Begin  { to ensure correct Graphic format }
                             bm.Bitmap.LoadFromFile(Editor.FBitMapName);
                             SetOrdValue(Longint(bm.BitMap));
                           End{pos}
                         else if Editor.Extension = pvIcon then
                           begin
                             Editor.Image.Picture.LoadFromFile(Editor.FBitMapName);
                             Editor.ConvertIcon(bm.BitMap);
                             SetOrdValue(Longint(bm.BitMap));
                           end;{ icon convert }
                       except
                       end;{try block}
                     end;{pvbitMap}
          end;{ case graphic type }
      end;{ mrOk }
  { Tab 1 result }
    mrYes :
    begin
      StrPCopy(str, Editor.FExeDllName);
      case Editor.graphicType of
        pvPicture, pvIcon :
          begin
            Try  { Get graphic and return it }
              StrPCopy(str, Editor.FExeDllName);
              bm.Icon.Handle := ExtractIcon(hInstance, str, Editor.FIconNbr);
              if bm.Icon.Handle > 1 then
                SetOrdValue(Longint(bm.Icon));
            except
            End;{Finally}
          end;{ get icon }
        pvBitmap : begin
                   try
                     Editor.IconImage.Picture.Icon.Handle :=
                               ExtractIcon(hInstance, str, Editor.FIconNbr);
                     Editor.ConvertIcon(bm.BitMap);
                     SetOrdValue(Longint(bm.BitMap));
                   except
                   end;{ try block }
                 end;
      end;{case of Graphictype }
    End;{ get icon from dll or exe }

    mrRetry :  { clear the Graphic }
    begin
      try
        case Editor.GraphicType of  { Send back a empty graphic image }
          pvPicture : SetOrdValue(Longint(bm));
          pvBitMap  : SetOrdValue(LongInt(bm.BitMap));
          pvIcon    : SetOrdValue(LongInt(bm.Icon));
        end;{ case}
      except
      End;{ try block }
    end; { end Clearing the graphic}
  end;{ case of button responses }
  Finally
    bm.Free;
  End;{try block}
  Editor.Free;
end;

procedure TpvBitMapIcon.DirectoryCheckSlash;
begin  { work around for the Directory bug }
  if Length(DirectoryListBox2.Directory) > 3 then
   CurrentDllExeDirectory := DirectoryListBox2.Directory + '\'
 else
   CurrentDllExeDirectory := DirectoryListBox2.Directory;
 if Length(DirectoryListBox1.Directory) > 3 then
   CurrentBmpDirectory := DirectoryListBox1.Directory + '\'
 else
   CurrentBmpDirectory := DirectoryListBox1.Directory;
end;

procedure TpvBitMapIcon.FormCreate(Sender: TObject);
var
  fptr : TextFile;

begin
 SelectedGraphic := 0; 
 RunExternal := False;
 BitMapEditor := '';
 IconEditor := '';
 MetaFileEditor := '';
 AssignFile(fptr,GraphicPaths);
 try
   try
     reset(fptr);
     Readln(fptr,BitMapEditor);
     Readln(fptr,IconEditor);
     Readln(fptr,MetaFileEditor);
   except
   end;
 Finally
   CloseFile(fptr);
 end;
 Extension := pvNone;
 FIconNbr    := 0;
 ReturnExe.Enabled := False;
 ReturnFile.Enabled := True;
 TabbedNotebook1.PageIndex := 0;
 DrawGraphicGrid.Visible := True;
 ListGraphicFiles.Visible := False;
 { Setting up the directorties and  }
 { Get Directory history lists}
 try    { just incase they don't exist }
   ExeDllHstList.Items.LoadFromFile(ExeDLLHistory);
   BitMapHstList.Items.LoadFromFile(BitMapHistory);
 except
 end; { try block }
 try  { set the Directroy list to first value if valid }
   if BitMapHstList.Items.Count > 0 then
     begin
       DirectoryListBox1.Directory := BitMapHstList.Items[0];
       BitMapHstList.ItemIndex := 0;
     end;
   if ExeDllHstList.Items.Count > 0 then
     begin
       DirectoryListBox2.Directory := ExeDllHstList.Items[0];
       ExeDllHstList.ItemIndex := 0;
     end;
 except
 end; { End try block }
 { set current directories }
 DirectoryCheckSlash;
end;

procedure TpvBitMapIcon.DirectoryListBox1Change(Sender: TObject);
var
  I,Previous : Integer;

begin
  DirectoryCheckSlash;
  NbrRead.Caption := 'Number read is ' + IntToStr(ListGraphicFiles.Items.Count);
 { Set The Graphic grid row and column values.  Then Draw cell will be called }
 { that many times.  If row = 5 and coulmn  = 5 then the draw cell will be    }
 { called 25 times }
 Previous := DrawGraphicGrid.RowCount;
 DrawGraphicGrid.RowCount := (ListGraphicFiles.Items.Count Div 5) + 1;
 If ListGraphicFiles.Items.Count < 5 then
   DrawGraphicGrid.ColCount := ListGraphicFiles.Items.Count
 Else
   DrawGraphicGrid.ColCount := 5;
 {DrawGraphicGrid.GridIndex := 0;
 { set the ListGraphicFiles to lower case, disable the grid if nothing to set }
 if ListGraphicFiles.Items.Count >= 0 Then
   begin
     for I := 0 to ListGraphicFiles.Items.Count -1 do
        ListGraphicFiles.Items[I] := LowerCase(ListGraphicFiles.Items[I]);
     DrawGraphicGrid.Enabled := True;
   end
else
   DrawGraphicGrid.Enabled := False;
{ to ensure the grid gets redrawn if the two directories have the same number of items}
if Previous = DrawGraphicGrid.RowCount then
   DrawGraphicGrid.RePaint;
end;

procedure TpvBitMapIcon.ListGraphicFilesClick(Sender: TObject);
begin
  SelectedGraphic := ListGraphicFiles.ItemIndex;
  if CurrentBmpDirectory + ListGraphicFiles.Items[ListGraphicFiles.ItemIndex] <> FBitMapName then
     AssignBitMapIcon(ListGraphicFiles.ItemIndex);
end;

procedure TpvBitMapIcon.DrawGraphicGridDrawCell(Sender: TObject; Col,
  Row: Longint; Rect: TRect; State: TGridDrawState);
var
  dg : TDrawGrid;
  pic : TPicture;{ for Wpf, Icons, BitMap Files }
  bm : TBitmap;  { for bitmap }
  AnIcon : TIcon; { for Icons }
  SRect, DRect : TRect;

begin
  TheIndex := (Row * 5) + Col;  { what file to use for the cell }
  If (ListGraphicFiles.Items.Count-1 >= 0) and
     (TheIndex <= ListGraphicFiles.Items.Count-1) Then
  begin
    dg := (Sender as TDrawGrid);
    SRect  := classes.Rect(0, 0, 32, 32);
    DRect  := classes.Rect(Rect.Left, Rect.Top,Rect.Left+32, Rect.Top+32);
    If (Pos('.bmp',ListGraphicFiles.Items[TheIndex]) > 0) then
    Begin
       bm := TBitMap.Create;
      Try
        bm.LoadFromFile(CurrentBmpDirectory + ListGraphicFiles.Items[TheIndex]);
        { Size to fit}
        if GridExeFit.Checked then
          SRect  := classes.Rect(0, 0, bm.Width, bm.Height);
        BmpSize.Caption := 'Graphic Size ' + IntToStr(bm.Width) +' by '
                                           + IntToStr(bm.Height);
        dg.Canvas.BrushCopy(DRect, bm, SRect,
        bm.Canvas.Pixels[0,bm.Height-1]);
      Except
      End;{try}
      bm.Free
    End{If BMP }
    Else If (Pos('.wmf',ListGraphicFiles.Items[TheIndex]) > 0) then
    Begin
       bm := TBitMap.Create;
       pic := TPicture.Create;
      Try { Read a metafile and convert it to a bitmap }
        pic.MetaFile.LoadFromFile(CurrentBmpDirectory + ListGraphicFiles.Items[TheIndex]);
        bm.Width := pic.Metafile.Width;
        bm.Height := pic.Metafile.Height;
        bm.Canvas.Draw(0, 0, pic.MetaFile);
        { Size to fit }
        if GridExeFit.Checked then
          SRect  := classes.Rect(0, 0, bm.Width, bm.Height);
        BmpSize.Caption := 'Graphic Size ' + IntToStr(bm.Width) +' by '
                                           + IntToStr(bm.Height);
        dg.Canvas.BrushCopy(DRect, bm, SRect,
        bm.Canvas.Pixels[0,bm.Height-1]);
      Except
      End;{try}
      bm.Free;
      pic.Free
    End { If Wpf Metafile }

    Else If Pos('.ico',ListGraphicFiles.Items[TheIndex]) > 0 then
    Begin
      AnIcon := TIcon.Create;
      Try    { load and display one Icon }
        AnIcon.LoadFromFile(CurrentBmpDirectory + ListGraphicFiles.Items[TheIndex]);
        BmpSize.Caption := 'Graphic Size ' + IntToStr(AnIcon.Width) +' by '
                                           + IntToStr(AnIcon.Height);
        dg.Canvas.Draw(Rect.Left, Rect.Top,AnIcon);
      except  { to catch exeception }
      End;{try}
      AnIcon.Free;
    end;{If for ICO File }
  end;
end;

Procedure TpvBitMapIcon.AssignBitMapIcon(CellIndex: Integer);
{ When a Item is clicked in the grid, display the image }

Begin  { set the extension type  removes eight calls to Pos saving 112 bytes }
  Try
    LastCell := CellIndex;
    FBitMapName := CurrentBmpDirectory + ListGraphicFiles.Items[CellIndex];
    if Pos('.ico',FBitMapName) > 0 then
      Extension := pvIcon
    else if Pos('.bmp',FBitMapName) > 0 then
      Extension := pvBitMap
    else if Pos('.wmf',FBitMapName) > 0 then
      Extension := pvMetaFile
    else
      Extension := pvNone;
    Image.Picture.LoadFromFile(FBitMapName);
    { if the graphic is a bitmap display in the buttons }
    If Extension = pvBitMap then
    Begin
      MakeFit.Enabled := true;
      BitBtnTest.Glyph := Image.Picture.BitMap;
      SpeedButtonTest.Glyph := BitBtnTest.Glyph;
    End
    else if Extension = pvIcon then
    begin
       MakeFit.Enabled := False;
      with SpeedButtonTest do  {Now do the same for the SpeedButton}
        begin
           ConvertIcon(Glyph);
           BitBtnTest.Glyph := Glyph;
        end;{ with}
    end;{ else }
    BitBtnTest.NumGlyphs := SpinEditGlyphs.Value;
    SpeedButtonTest.NumGlyphs := SpinEditGlyphs.Value;
  Except
    MessageDlg('Invalid BitMap or Icon, Unable to Load', mtWarning, [mbOk], 0);
  end;
End;

procedure TpvBitMapIcon.DrawGraphicGridClick(Sender: TObject);
var
 NbrCell : integer;
 LaunchEditor: TLaunchEditor;

begin  { display the bitmap }
  NbrCell := (DrawGraphicGrid.Row*5)+DrawGraphicGrid.Col;
  SelectedGraphic := NbrCell;
  if NbrCell > ListGraphicFiles.Items.Count-1 then
  begin
    LaunchEditor := TLaunchEditor.Create(Application);
    Try
      LaunchEditor.ShowModal;
    Finally
     LaunchEditor.Free;
   end;{ Try block}
  end
  else if (ListGraphicFiles.Items.Count-1 >= 0) and (NbrCell <= ListGraphicFiles.Items.Count-1) then
    if CurrentBmpDirectory + ListGraphicFiles.Items[NbrCell] <> FBitMapName then
      AssignBitMapIcon(NbrCell);
end;

procedure TpvBitMapIcon.SpinEditGlyphsChange(Sender: TObject);
begin  { set the number of glyths for the buttons }
  BitBtnTest.NumGlyphs := SpinEditGlyphs.Value;
  SpeedButtonTest.NumGlyphs := SpinEditGlyphs.Value;
end;

procedure TpvBitMapIcon.MakeFitClick(Sender: TObject);
begin  { If Makefit.Checked os true the image is fit }
  Image.Stretch := MakeFit.Checked
end;

procedure TpvBitMapIcon.FormMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin    { to display the grid or file list but not both }
  If Button = mbRight then
  begin
   DrawGraphicGrid.Visible := not DrawGraphicGrid.Visible;
   ListGraphicFiles.Visible :=  not ListGraphicFiles.Visible;
   PlaceTheFormCaption;
   if ListGraphicFiles.Visible then
      ListGraphicFiles.ItemIndex := LastCell
   else
     begin
       DrawGraphicGrid.Row := (LastCell Div 5);
       if DrawGraphicGrid.Row > 0 then
         DrawGraphicGrid.Col := LastCell-(DrawGraphicGrid.Row*5)
       else
         DrawGraphicGrid.Col := LastCell;
     end;
  end;
end;

procedure TpvBitMapIcon.PlaceTheFormCaption;
begin     { determines property editor title }
  case TabbedNotebook1.PageIndex of
    0 : if DrawGraphicGrid.Visible then
          Caption := ' The ' + GraphicName + ' : BitMapIconGrabber >> Graphic View'
        Else
          Caption := ' The ' + GraphicName + ' : BitMapIconGrabber >> File List View';
    1 : Caption := ' The ' + GraphicName + ' : BitMapIconGrabber >> Graphic View'
  end;{case}
end;

procedure TpvBitMapIcon.SetDllexeValues;
var
 i : integer;
          { if exe one icon, if dll, determine how many }
begin
   if Pos('.exe',DllExeFileName) <> 0 then
    begin
      IconImage.Picture.Icon.Handle := ExtractIcon(hInstance, str, 0);
      MaxIcons := 1;
      DrawIcons.RowCount := 1;
      DrawIcons.ColCount := 1;
    end
  else  if Pos('.dll',DllExeFileName) <> 0 then
    Begin
      i := -1;
      MaxIcons := ExtractIcon(hInstance, str, i);
      DrawIcons.RowCount := (MaxIcons  Div 5) + 1;
      If MaxIcons  < 5 then
        DrawIcons.ColCount := MaxIcons
      Else
        DrawIcons.ColCount := 5;
    end;
    NbrIconRead.Caption := 'Number Read in ' + IntToStr(MaxIcons);
   { if MaxIcons = 1 then}
      DrawIcons.Refresh;
 end;

procedure TpvBitMapIcon.FileListDllExeClick(Sender: TObject);
var
  StrTemp : String[255];

begin
   strTemp := CurrentDllExeDirectory + FileListDllExe.Items[FileListDllExe.ItemIndex];
   { file name has to change before the icons can be reread }
   if DllExeFileName <> StrTemp then
   begin
     DllExeFileName := StrTemp;
     FExeDllName := DllExeFileName;
     StrPCopy(str, DllExeFileName);
     SetDllexeValues; { determines icon numbers}
   end;
end;

procedure TpvBitMapIcon.DrawIconsDrawCell(Sender: TObject; Col, Row: Longint;
  Rect: TRect; State: TGridDrawState);
var                { draws one cell of the grid }
  dg : TDrawGrid;
  AnIcon : TIcon;
  SRect, DRect : TRect;

begin     { determines which Icon goes in the grid position [row,col]}
    TheIconIndex := (Row * 5) + Col;
    AnIcon := TIcon.Create;
    Try
      dg := (Sender as TDrawGrid);
      SRect  := classes.Rect(0, 0, 32, 32);
      DRect  := classes.Rect(Rect.Left, Rect.Top,Rect.Left+32, Rect.Top+32);
      AnIcon.Handle := ExtractIcon(hInstance, str, TheIconIndex);
      dg.Canvas.Draw(Rect.Left, Rect.Top,AnIcon);
    Except { to catch exception }
    End;{try}
    AnIcon.Free;
end;  { proc }

procedure TpvBitMapIcon.DirectoryListBox2Click(Sender: TObject);
begin
  { get current Directory for the DllExe page }
 DirectoryCheckSlash;
end;

procedure TpvBitMapIcon.DrawIconsClick(Sender: TObject);
var
 bm : TBitMap;

 begin        { An icon was picked from the grid }
  FIconNbr := (DrawIcons.Row*5)+DrawIcons.Col;
  if FIconNbr <= MaxIcons then
  begin
    IconImage.Picture.Icon.Handle := ExtractIcon(hInstance, str, FIconNbr);
    bm := TBitMap.Create;
    try
      ConvertIcon(bm);
      with BitBtnIconTest do  { put icon on button }
        Glyph := bm;
    Finally
      bm.Free;
    end;
  end;{ if valid }
end;

procedure TpvBitMapIcon.DirectoryListBox2Change(Sender: TObject);
var
 i : integer;
begin  { new directory clears the icons from the grid }
  MaxIcons := 0; { DrawIcons grid will redraw with new values }
  DrawIcons.RowCount := 1;
  DrawIcons.ColCount := 1;
  StrPCopy(str, '');  { sets the new directory to lower case}
  for I :=  0 to FileListDllExe.Items.Count-1 do
    FileListDllExe.Items[i] := LowerCase(FileListDllExe.Items[i]);
  DirectoryListBox2Click(Sender);
end;

procedure TpvBitMapIcon.SaveIconClick(Sender: TObject);

begin { Save Grabbed Icon to a fileName }
  If SaveDialog.Execute then
    IconImage.Picture.Icon.SaveToFile(SaveDialog.FileName);
    { Reset directory and force a redraw }
  ListGraphicFiles.FileType:= [ftSystem];
  ListGraphicFiles.FileType:= [ftNormal];
end;

procedure TpvBitMapIcon.GridExeFitClick(Sender: TObject);
begin
  DrawGraphicGrid.Invalidate  { reDraws the grid, will use the checked }
end;                          { property to inside the drawcell procedure }


procedure TpvBitMapIcon.ConvertIcon(bm : TBitMap);

begin  { get filename }
   { get icon if possible }
    Case TabbedNotebook1.PageIndex of
      0 : if Image.Picture.Icon.Handle > 1 then
          begin
           try
             bm.Height := Image.Picture.Icon.Height;
             bm.Width := Image.Picture.Icon.Width;
             bm.Canvas.Draw(0, 0, Image.Picture.Icon);
           except
           end;{ try on bm}
         end; { icon handle good }

      1 : if IconImage.Picture.Icon.Handle > 1 then
          begin
           try
             bm.Height := IconImage.Picture.Icon.Height;
             bm.Width := IconImage.Picture.Icon.Width;
             bm.Canvas.Draw(0, 0, IconImage.Picture.Icon);
           except
           end;{ try on bm}
         end; { icon handle good }
    End;{case}
end;

procedure TpvBitMapIcon.BitBtnConvertClick(Sender: TObject);
var
  bm : TBitMap;
  
   { convert Icon to BitMap and save it }
begin  { get filename }
  if SaveDialogBMP.Execute then
  begin
    bm := TBitMap.Create;
    try
      ConvertIcon(bm);
      bm.SaveToFile(SaveDialogBMP.FileName);  { save icon as bitmap}
    finally
      bm.Free;
    end;{Finally on bitmap }
    if TabbedNotebook1.PageIndex = 1 then
    begin
      ListGraphicFiles.FileType:= [ftSystem];
      ListGraphicFiles.FileType:= [ftNormal];
    end;{ force a redraw of the files }
  end;{ good file name}
end; { proc }

procedure TpvBitMapIcon.ReturnFileClick(Sender: TObject);
var
  Found : Boolean;
  i : integer;

begin
  Found := false;
  i := 0;
  with BitMapHstList do
    While Not(Found) and (i <= Items.Count) Do
    begin
      if CompareText(Items[i],DirectoryListBox1.Directory)=0 then
        Found := true;
      inc(i)
    end;
  If not (Found) then
    BitMapHstList.Items.Insert(0,DirectoryListBox1.Directory);
  BitMapHstList.Items.SaveToFile(BitMapHistory);
end;

procedure TpvBitMapIcon.ReturnExeClick(Sender: TObject);
var
  Found : Boolean;
  i : integer;

begin
  Found := false;
  i := 0;
  with ExeDllHstList do
    While Not(Found) and (i <= Items.Count) Do
    begin
      if CompareText(Items[i],DirectoryListBox2.Directory)=0 then
        Found := true;
      inc(i)
    end;
  If not (Found) then
    ExeDllHstList.Items.Insert(0,DirectoryListBox2.Directory);
  ExeDllHstList.Items.SaveToFile(ExeDLLHistory);
end;

procedure TpvBitMapIcon.BitMapHstListClick(Sender: TObject);
var
  temp : TFilename;

begin  { make sure the list has something in it }
  if BitMapHstList.Items.Count > 0 then
  begin
    with BitMapHstList do
      If ItemIndex <> 0  then
      begin { put picked Item as first Item }
        Temp := Items[ItemIndex];
        Items.Delete(ItemIndex);
        Items.Insert(0,temp);
        ItemIndex := 0
      end;
    try
      DirectoryListBox1.Directory := BitMapHstList.Items[0];
      DirectoryCheckSlash;
    Except
    end;{ try block }
  end; { if statement}
end;  { proc }

procedure TpvBitMapIcon.ExeDllHstListClick(Sender: TObject);
var
  temp : TFilename;

begin       { make sure the list has something in it }
 if ExeDllHstList.Items.Count > 0 then
  begin
    with ExeDllHstList do
      If ItemIndex <> 0  then
      begin { put picked Item as first Item }
        Temp := Items[ItemIndex];
        Items.Delete(ItemIndex);
        Items.Insert(0,temp);
        ItemIndex := 0
      end;
    try
      DirectoryListBox2.Directory := ExeDllHstList.Items[0];
      DirectoryCheckSlash;
    Except
    end;{ end try block }
  end;{if}
end; { proc }

procedure TpvBitMapIcon.ExeDllHstListKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var        { Delete an item form the history list }
  temp : String;

begin
  if Key = VK_DELETE then
  begin
    temp := 'Do you what to delete this Directory from the list'+chr(13);
    Case TabbedNotebook1.PageIndex of
      0 : begin
           with BitMapHstList do
           begin
             temp := temp + Items[ItemIndex];
             if MessageDlg(temp, mtWarning, [mbYes, mbNo], 0) = mrYes then
             begin
              Items.Delete(ItemIndex);
              BitMapHstList.Items.SaveToFile(BitMapHistory);
              if Items.Count > 0 then
                ItemIndex := 0
             end;{ MsgBox }
           end; { with }
          end;   { case  0 }
      1 : begin
            with ExeDllHstList do
            begin
              temp := temp + Items[ItemIndex];
              if MessageDlg(temp, mtWarning, [mbYes, mbNo], 0) = mrYes then
              begin
               Items.Delete(ItemIndex);
               ExeDllHstList.Items.SaveToFile(ExeDLLHistory);
               if Items.Count > 0 then
                 ItemIndex := 0
              end;{ MsgBox }
            end; { with }
          end; { case value 1 }
      End;{ case}
    end;{ key state }
end;

procedure TpvBitMapIcon.TabbedNotebook1Change(Sender: TObject;
  NewTab: Integer; var AllowChange: Boolean);
var
  temp : string;
  LastPick,i : integer;

begin { Determines the state of each page when selected }
  if AllowChange then
  begin
    PlaceTheFormCaption;
    Case TabbedNotebook1.PageIndex of
      0 : begin
            ReturnExe.Enabled := True;
            ReturnFile.Enabled := False;
          end;
      1 : begin
            ReturnExe.Enabled := False;
            ReturnFile.Enabled := True;
            temp := '';
            for i := 1 to Length(CurrentDllExeDirectory)-1 do
              temp := temp + CurrentDllExeDirectory[i];
            LastPick := 0;
            if CompareText(DirectoryListBox2.Directory, temp) <> 0 then
            begin
              LastPick := FileListDllExe.ItemIndex;
              DirectoryListBox2.Directory := CurrentDllExeDirectory;
              FileListDllExe.ItemIndex := LastPick;
            end;
            if (FileListDllExe.ItemIndex > 0) and (LastPick <= FileListDllExe.Items.count) then
              FileListDllExeClick(Sender);
          end;
    end;{case}
  end;{ allow change }
end;{ proc }

procedure TpvBitMapIcon.FormShow(Sender: TObject);
const
  MaskTypes : array[TGraphicType] of TFileName =
              ('*.BMP;*.ICO;*.wmf','*.ICO','*.Bmp;*.ICO','*.wmf','*.*');
begin
 ListGraphicFiles.Mask := MaskTypes[GraphicType];
 PlaceTheFormCaption;
 DirectoryListBox1Change(sender)
end;

procedure TpvBitMapIcon.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var
  str,temp : string;
  PathForm: TPathForm;
  Pstr : array[0..255] of char;

begin   { copy bitmap or MetaFile to clipboard from tab 0 }
 if  (Shift=[ssCtrl]) and not(RunExternal) then
  case Key of
    Ord('C') : if FBitMapName<>'' then
                begin
                 Clipboard.Clear;
                 case GraphicType of
                   pvPicture : if Extension <> pvIcon then
                                 Clipboard.Assign(Image.Picture);
                   pvBitMap  : Clipboard.Assign(Image.Picture.BitMap);
                 end;{ Case }
               end;{ if statement}

    Ord('A') : begin
                 str := 'Author : Mark O. Purvis'+Chr(13)+' Freeware Plus Source'+chr(13)+'      Just Because'+chr(13);
                 MessageDlg(str,mtWarning	,[mbAbort], 0)
               end;
    Ord('E') :  if  (TabbedNotebook1.PageIndex = 0) and (FBitMapName<>'') then
                   begin
                     str := '';
                     Case Extension of
                       pvIcon     : if IconEditor <> '' then
                                      Str := IconEditor + ' '+ FBitMapName;
                       pvBitMap   : if BitMapEditor <> '' then
                                      Str :=  BitMapEditor + ' ' + FBitMapName;
                       pvMetaFile : if MetaFileEditor <> '' then
                                      Str :=  MetaFileEditor + ' '+ FBitMapName;
                     end;{case}
                     RunExternal := true;
                     {$IFDEF WIN32}
                      WinExecAndWait(Str,SW_SHOW);
	                  	{$ELSE}
                      StrPcopy(Pstr,str);
                      WinExecAndWait(PStr,SW_SHOW);
		                  {$ENDIF}
                     RunExternal := False;
                     {if Str <> '' then
                     begin
                       temp := ListGraphicFiles.Directory;
                       ListGraphicFiles.Directory := 'C:\';
                       ListGraphicFiles.Directory := Temp;
                     end; }
                   end;
    Ord('P') : begin
                 PathForm := TPathForm.Create(Application);
                 try
                   PathForm.ShowModal;
                 Finally
                   PathForm.Free;
                 end;
               end;
  end;{case of key}
end;

procedure TpvBitMapIcon.BitBtnCancelClick(Sender: TObject);
begin
  if MessageDlg('Are you sure you want to Cancel',mtInformation,
                [mbYes, mbNo], 0) = mrYes then
    ModalResult := BitBtnCancel.ModalResult
  else
    ModalResult := mrNone
end;

procedure TpvBitMapIcon.BitBtnClearClick(Sender: TObject);
begin
  if MessageDlg('Are you sure you want to Clear the Sending graphic ',
               mtInformation,[mbYes, mbNo], 0) = mrYes then
    ModalResult := BitBtnClear.ModalResult
  else
    ModalResult := mrNone
end;

procedure TpvBitMapIcon.FormClose(Sender: TObject;
  var Action: TCloseAction);
var
  fptr : TextFile;

begin
AssignFile(fptr,GraphicPaths);
 try
   reWrite(fptr);
   Writeln(fptr,BitMapEditor);
   Writeln(fptr,IconEditor);
   Writeln(fptr,MetaFileEditor);
 Finally
   CloseFile(fptr);
 end;
end;
       { This Function was taken from Dtopics }
{$IFDEF WIN32}
function TpvBitMapIcon.WinExecAndWait(FileName:String; Visibility : integer):integer;
  var
    zAppName:array[0..512] of char;
    zCurDir:array[0..255] of char;
    WorkDir:String;
    StartupInfo:TStartupInfo;
    ProcessInfo:TProcessInformation;

  begin
    StrPCopy(zAppName,FileName);
    GetDir(0,WorkDir);
    StrPCopy(zCurDir,WorkDir);
    FillChar(StartupInfo,Sizeof(StartupInfo),#0);
    StartupInfo.cb := Sizeof(StartupInfo);
    StartupInfo.dwFlags := STARTF_USESHOWWINDOW;
    StartupInfo.wShowWindow := Visibility;
    if not CreateProcess(nil,
      zAppName,                      { pointer to command line string }
      nil,                          { pointer to process security attributes }
      nil,                           { pointer to thread security attributes }
      false,                         { handle inheritance flag }
      CREATE_NEW_CONSOLE or          { creation flags }
      NORMAL_PRIORITY_CLASS,
      nil,                           { pointer to new environment block }
      nil,                           { pointer to current directory name }
      StartupInfo,                   { pointer to STARTUPINFO }
      ProcessInfo) then Result := -1 { pointer to PROCESS_INF }
    else
       begin
         WaitforSingleObject(ProcessInfo.hProcess,INFINITE);
         GetExitCodeProcess(ProcessInfo.hProcess,Result);
       end;
  end;

{$ELSE}

 Function TpvBitMapIcon.WinExecAndWait(Path : Pchar; Visibility : word) : word;
  var
    InstanceID : THandle;
    Msg : TMSg;
  begin
    InstanceID := WinExec(Path,Visibility);
    if InstanceID < 32 then { a value less than 32 indicates an Exec error }
       WinExecAndWait := InstanceID
    else
     begin
     Repeat
      While PeekMessage(Msg,0,0,0,PM_REMOVE) do
         begin
         if Msg.Message = WM_QUIT then
            halt(Msg.wParam);
         TranslateMessage(Msg);
         DispatchMessage(Msg);
         end;
     until GetModuleUsage(InstanceID) = 0;
     WinExecAndWait := 32;
     end;
  end;
{$ENDIF}

procedure TpvBitMapIcon.DrawGraphicGridDblClick(Sender: TObject);
 var
   Key: Word;
   Shift: TShiftState;
   Row,Col : LongInt;
   Rect: TRect;
   State: TGridDrawState;

begin
  Key :=  ord('E');
  Shift := [ssCtrl];
  row := DrawGraphicGrid.Row;
  col := DrawGraphicGrid.Col;
  FormKeyDown(Sender, Key, Shift);
  DrawGraphicGridDrawCell(DrawGraphicGrid, Col, Row,Rect,State);
  AssignBitMapIcon(LastCell);
end;

Function TpvBitMapIcon.PerformDeletion : Boolean;
var
  TheFileName,Temp : TFileName;

begin
  Result := true;
  Temp :=  ExtractFilePath(FBitMapName);
  if temp <> DeletePath then
  begin
    temp := '';
    Try
      if not(DirectoryExists(DeletePath)) then
        MkDir(DeletePath);
      temp := ExtractFileName(FBitMapName);
      TheFileName :=  DeletePath +'\'+ Temp;
      case Extension of
        pvIcon     : Image.Picture.Icon.SaveToFile(TheFileName);
        pvBitMap   : Image.Picture.BitMap.SaveToFile(TheFileName);
        pvMetaFile : Image.Picture.MetaFile.SaveToFile(TheFileName);
      end;{case}
    except
      temp := 'Exception on saving deleted file'+Chr(13)+'Perform hard delete on File?';
      if MessageDlg(temp, mtWarning, [mbYes, mbNo], 0) = mrYes then
        Result := True
      else
        Result := False;
    end;{ except block}
  end{if}
  else
     Result := False;
end;

procedure TpvBitMapIcon.DrawGraphicGridKeyDown(Sender: TObject;
  var Key: Word; Shift: TShiftState);
var
  Temp : String[127];

begin
   if (Key = VK_DELETE) and (SelectedGraphic <= ListGraphicFiles.Items.Count-1) then
     Begin
       temp := 'Are you Sure you Want to delete this Icon file' +
               Chr(13)+'<< '+ FBitMapName+' >>';
       if MessageDlg(temp, mtWarning, [mbYes, mbNo], 0) = mrYes then
       begin
         if PerformDeletion then
           try
             DeleteFile(FBitMapName);
           finally
             FBitMapName := '';
             ListGraphicFiles.Items.Delete(LastCell);
             NbrRead.Caption := 'Number read is ' + IntToStr(ListGraphicFiles.Items.Count);
             DrawGraphicGrid.RowCount := (ListGraphicFiles.Items.Count Div 5) + 1;
             If ListGraphicFiles.Items.Count < 5 then
               DrawGraphicGrid.ColCount := ListGraphicFiles.Items.Count
             Else
               DrawGraphicGrid.ColCount := 5;
             DrawGraphicGrid.RePaint;
             if (ListGraphicFiles.Items.Count-1 > 0) and
              (LastCell <= ListGraphicFiles.Items.Count-1) then
               AssignBitMapIcon(LastCell)
             else
               begin
                 Dec(LastCell);
                 if LastCell < 0 then
                   LastCell := 0
               end;
           end;{ try block}
       end; { if yes, deleted saved }
     end; { if delete key pressed }
   end;{ proc}
end.
